{
  pkgs ? import <nixpkgs> {},
  vendorHash ? "sha256-19z+/CD45jtKSCOooCQaVX4YvMFSp+aDaUIXlLMPLkA=",
  npmDepsHash ? "sha256-B4z5s8jSu9oQbINAhfff52dI7KZj5ksTxt6RDFm4MWI=",
}: rec {
  default = roleypoly;

  roleypoly = pkgs.buildGoModule {
    inherit vendorHash;
    name = "roleypoly";
    src = ./.;

    preBuild = ''
      ${pkgs.lightningcss}/bin/lightningcss --minify --bundle --targets '>= 0.25%' static/main.css -o static/main.css
    '';
  };
  container = pkgs.dockerTools.buildImage {
    name = "roleypoly/roleypoly";
    tag = "latest";
    copyToRoot = [ 
      pkgs.dockerTools.caCertificates
    ];
    config = {
      Cmd = [ "${roleypoly}/bin/roleypoly" ];
    };
  };
}