package discord_test

import (
	"testing"

	"github.com/stretchr/testify/assert"

	"git.sapphic.engineer/roleypoly/v4/discord"
	"git.sapphic.engineer/roleypoly/v4/discord/clientmock"
	"git.sapphic.engineer/roleypoly/v4/types/fixtures"
	"git.sapphic.engineer/roleypoly/v4/utils"
)

var (
	fixtureMember = &discord.Member{
		DiscordMember: fixtures.Member,
	}
)

func TestGetMember(t *testing.T) {
	dc := clientmock.NewDiscordClientMock()
	g := discord.Guild{
		Client:       dc,
		DiscordGuild: fixtures.Guild,
	}

	dc.MockResponse("GET", utils.J("guilds", fixtures.Guild.ID, "members", fixtureMember.User.ID), 200, fixtureMember)

	m, err := g.GetMember("41666")
	assert.Nil(t, err)
	assert.Equal(t, "Doll", m.Nick)
}
