package discord_test

import (
	"testing"

	"git.sapphic.engineer/roleypoly/v4/discord"
	"git.sapphic.engineer/roleypoly/v4/discord/clientmock"
	"git.sapphic.engineer/roleypoly/v4/types/fixtures"
	"git.sapphic.engineer/roleypoly/v4/utils"
	"github.com/stretchr/testify/assert"
)

var (
	fixtureGuild = &discord.Guild{
		DiscordGuild: fixtures.Guild,
	}
)

func TestGetGuild(t *testing.T) {
	dc := clientmock.NewDiscordClientMock()
	gs := discord.NewGuildService(dc)

	dc.MockResponse("GET", utils.J("guilds", fixtures.Guild.ID), 200, fixtureGuild)

	g, err := gs.GetGuild("1312")
	assert.Nil(t, err)
	assert.Equal(t, "1312", g.ID)
}
