package main // import "git.sapphic.engineer/roleypoly/v4"

import (
	"log"

	"git.sapphic.engineer/roleypoly/v4/discord"
	"git.sapphic.engineer/roleypoly/v4/roleypoly"
	"git.sapphic.engineer/roleypoly/v4/utils"
)

func main() {
	app := roleypoly.CreateFiberApp()

	dc := discord.NewDiscordClient(
		utils.DiscordClientID,
		utils.DiscordClientSecret,
		utils.DiscordBotToken,
	)

	roleypoly.SetupStatic(app)
	roleypoly.SetupControllers(
		app,
		roleypoly.ControllerConfig{
			DiscordClient: dc,
			PublicKey:     utils.DiscordPublicKey,
			PublicBaseURL: utils.PublicBaseURL,
			SupportIDs:    utils.SupportIDs,
			SuperuserIDs:  utils.SupueruserIDs,
		},
	)

	log.Fatal(app.Listen(utils.ListenAddr))
}
