package roleypoly_test

import (
	"bytes"
	"net/http"
	"testing"

	"git.sapphic.engineer/roleypoly/v4/roleypoly"
	"github.com/stretchr/testify/assert"
)

func TestStaticRoot(t *testing.T) {
	app := roleypoly.CreateFiberApp()
	roleypoly.SetupStatic(app)

	req, err := http.NewRequest("GET", "/humans.txt", nil)
	assert.Nil(t, err)

	resp, err := app.Test(req)
	assert.Nil(t, err)

	buf := bytes.Buffer{}
	buf.ReadFrom(resp.Body)
	assert.Equal(t, "you're on thin ice, soup head.", buf.String())
}

func TestStaticPath(t *testing.T) {
	app := roleypoly.CreateFiberApp()
	roleypoly.SetupStatic(app)

	req, err := http.NewRequest("GET", "/static/humans.txt", nil)
	assert.Nil(t, err)

	resp, err := app.Test(req)
	assert.Nil(t, err)

	buf := bytes.Buffer{}
	buf.ReadFrom(resp.Body)
	assert.Equal(t, "you're on thin ice, soup head.", buf.String())
}
