#!/usr/bin/env nix-shell
#!nix-shell -i bash -p nix -p coreutils -p gnused -p gawk -p prefetch-npm-deps

set -exuo pipefail

# NPM
checksum=$(prefetch-npm-deps package-lock.json)
sed -i -e "s|npmDepsHash ? \".*\"|npmDepsHash ? \"$checksum\"|" default.nix

# Go
go mod tidy
failedbuild=$(nix build --impure --expr '(with import <nixpkgs> {}; pkgs.callPackage ./. { vendorHash = ""; }).roleypoly' 2>&1 || true)
echo "$failedbuild"
checksum=$(echo "$failedbuild" | awk '/got:.*sha256/ { print $2 }')
sed -i -e "s|vendorHash ? \".*\"|vendorHash ? \"$checksum\"|" default.nix