package components

import (
	"git.sapphic.engineer/roleypoly/v4/types"
)

type CategoryTemplateData struct {
	ID    string
	Name  string
	Type  types.CategoryType
	Roles []RoleTemplateData
}

func Category(cat *types.Category, roles []*types.Role) CategoryTemplateData {
	rtd := make([]RoleTemplateData, len(roles))

	for i, role := range roles {
		rtd[i] = Role(cat, role)
	}

	return CategoryTemplateData{
		ID:    cat.ID,
		Name:  cat.Name,
		Type:  cat.Type,
		Roles: rtd,
	}
}
