// Package testing provides test helpers that support fiber templates
package templatetesting

import (
	"bytes"
	"testing"

	"git.sapphic.engineer/roleypoly/v4/roleypoly"
	"github.com/stretchr/testify/assert"
)

var (
	viewEngine = roleypoly.CreateViewEngine()
)

func Template(t *testing.T, name string, data interface{}, layout ...string) string {
	buf := bytes.Buffer{}

	err := viewEngine.Render(&buf, name, data, layout...)
	assert.NoError(t, err)
	return buf.String()
}
